---

- hosts: host1
  tasks:

    - name: Dump float configuration
      copy:
        dest: /tmp/test-config.yml
        content: "{{ vars | to_nice_yaml }}"

    - name: Create test artifact directory
      file:
        path: "/artifacts"
        state: directory
        mode: "01777"

    - name: Pull the test suite container image
      command: "float-pull-image {{ test_image }}"
      register: test_container_image
      failed_when: "test_container_image.rc not in [0, 42]"

    - name: Run tests
      command: "podman run --rm --network host --mount type=bind,source=/tmp/test-config.yml,destination=/test-config.yml --mount type=bind,source=/artifacts,destination=/artifacts {{ test_image }}"

    - name: Check existence of pytest.xml
      stat:
        path: "/artifacts/pytest.xml"
      register: pytest_xml_stat

    - name: Retrieve test result
      slurp:
        src: "/artifacts/pytest.xml"
      register: pytest_xml
      when: "pytest_xml_stat.stat.exists"

    - name: Store test results locally
      local_action:
        module: copy
        dest: "{{ lookup('env', 'CI_PROJECT_DIR') | default('..') }}/pytest.xml"
        content: "{{ pytest_xml['content'] | b64decode }}"
      when: "pytest_xml_stat.stat.exists"

  vars:
    test_image: "registry.git.autistici.org/ai3/float:integration-test"
